panelapp/api/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.urls import path, include
from django.conf import settings
from drf_yasg.views import get_schema_view
from drf_yasg import openapi
from .permissions import ReadOnlyPermissions

schema_view = get_schema_view(
    openapi.Info(
        title="PanelApp API",
        default_version=settings.REST_FRAMEWORK["DEFAULT_VERSION"],
        description="PanelApp API",
        terms_of_service="https://panelapp.genomicsengland.co.uk/policies/terms/",
        contact=openapi.Contact(email="panelapp@genomicsengland.co.uk"),
        license=openapi.License(name="MIT License"),
    ),
    patterns=["api"],
    validators=["flex", "ssv"],
    public=True,
    permission_classes=(ReadOnlyPermissions,),
)

app_name = "api"
urlpatterns = [path("v1/", include("api.v1.urls", namespace="v1"))]

panelapp/panels/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.conf.urls import url

from django.views.generic import RedirectView
from .views import AdminView
from .views import AdminUploadGenesView
from .views import AdminUploadPanelsView
from .views import AdminUploadReviewsView
from .views import EntitiesListView
from .views import CreatePanelView
from .views import EntityDetailView
from .views import GenePanelView
from .views import PanelsIndexView
from .views import UpdatePanelView
from .views import PromotePanelView
from .views import PanelAddEntityView
from .views import PanelEditEntityView
from .views import PanelMarkNotReadyView
from .views import GenePanelSpanshotView
from .views import EntityReviewView
from .views import MarkEntityReadyView
from .views import DownloadPanelTSVView
from .views import DownloadPanelVersionTSVView
from .views import MarkGeneNotReadyView
from .views import ComparePanelsView
from .views import CompareGeneView
from .views import CopyReviewsView
from .views import DownloadAllGenes
from .views import DownloadAllPanels
from .views import ActivityListView
from .views import DownloadAllSTRs
from .views import DownloadAllRegions
from .views import GeneDetailRedirectView
from .views import RedirectGenesToEntities
from .views import OldCodeURLRedirect
from .ajax_views import ClearPublicationsAjaxView
from .ajax_views import ClearPhoenotypesAjaxView
from .ajax_views import ClearModeOfPathogenicityAjaxView
from .ajax_views import ClearSourcesAjaxView
from .ajax_views import ClearSingleSourceAjaxView
from .ajax_views import DeletePanelAjaxView
from .ajax_views import DeleteEntityAjaxView
from .ajax_views import RejectPanelAjaxView
from .ajax_views import ApprovePanelAjaxView
from .ajax_views import UpdateEntityTagsAjaxView
from .ajax_views import UpdateEntityMOPAjaxView
from .ajax_views import UpdateEntityMOIAjaxView
from .ajax_views import UpdateEntityPhenotypesAjaxView
from .ajax_views import UpdateEntityPublicationsAjaxView
from .ajax_views import UpdateEntityRatingAjaxView
from .ajax_views import DeleteEntityEvaluationAjaxView
from .ajax_views import GetEntityCommentFormAjaxView
from .ajax_views import DeleteEntityCommentAjaxView
from .ajax_views import SubmitEntityCommentFormAjaxView
from .ajax_views import ApproveEntityAjaxView


app_name = "panels"

entity_regex = "[\w\-\.\$\~\@\#\ ]+"
entity_types = "gene|str|region"

urlpatterns = [
    url(r"^$", PanelsIndexView.as_view(), name="index"),
    url(r"^compare/$", ComparePanelsView.as_view(), name="compare_panels_form"),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        ComparePanelsView.as_view(),
        name="compare",
    ),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)/(?P<gene_symbol>[\w\-]+)$",
        CompareGeneView.as_view(),
        name="compare_genes",
    ),
    url(
        r"^copy/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        CopyReviewsView.as_view(),
        name="copy_reviews",
    ),
    url(r"^(?P<pk>[0-9]+)/$", GenePanelView.as_view(), name="detail"),
    url(r"^(?P<pk>[0-9]+)/update$", UpdatePanelView.as_view(), name="update"),
    url(r"^(?P<pk>[0-9]+)/promote$", PromotePanelView.as_view(), name="promote"),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/add".format(types=entity_types),
        PanelAddEntityView.as_view(),
        name="add_entity",
    ),
    url(r"^(?P<pk>[0-9]+)/delete$", DeletePanelAjaxView.as_view(), name="delete_panel"),
    url(r"^(?P<pk>[0-9]+)/reject$", RejectPanelAjaxView.as_view(), name="reject_panel"),
    url(
        r"^(?P<pk>[0-9]+)/approve$",
        ApprovePanelAjaxView.as_view(),
        name="approve_panel",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download/(?P<categories>[0-4]+)/$",
        DownloadPanelTSVView.as_view(),
        name="download_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download_version/$",
        DownloadPanelVersionTSVView.as_view(),
        name="download_old_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_name>{})/$".format(entity_regex),
        RedirectGenesToEntities.as_view(),
        name="redirect_previous_structure",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/$".format(
            types=entity_types, regex=entity_regex
        ),
        GenePanelSpanshotView.as_view(),
        name="evaluation",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/edit$".format(
            types=entity_types, regex=entity_regex
        ),
        PanelEditEntityView.as_view(),
        name="edit_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/review$".format(
            types=entity_types, regex=entity_regex
        ),
        EntityReviewView.as_view(),
        name="review_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkEntityReadyView.as_view(),
        name="mark_entity_as_ready",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_not_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkGeneNotReadyView.as_view(),
        name="mark_entity_as_not_ready",
    ),
    # AJAX endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/delete$".format(
            types=entity_types, regex=entity_regex
        ),
        DeleteEntityAjaxView.as_view(),
        name="delete_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/approve$".format(
            types=entity_types, regex=entity_regex
        ),
        ApproveEntityAjaxView.as_view(),
        name="approve_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_sources$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSourcesAjaxView.as_view(),
        name="clear_entity_sources",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_source/(?P<source>(.*))/$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSingleSourceAjaxView.as_view(),
        name="clear_entity_source",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_phenotypes$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPhoenotypesAjaxView.as_view(),
        name="clear_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_publications$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPublicationsAjaxView.as_view(),
        name="clear_entity_publications",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_mode_of_pathogenicity$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearModeOfPathogenicityAjaxView.as_view(),
        name="clear_entity_mode_of_pathogenicity",
    ),
    # AJAX Review endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_tags/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityTagsAjaxView.as_view(),
        name="update_entity_tags",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_rating/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityRatingAjaxView.as_view(),
        name="update_entity_rating",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_moi/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOIAjaxView.as_view(),
        name="update_entity_moi",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_mop/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOPAjaxView.as_view(),
        name="update_entity_mop",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_phenotypes/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPhenotypesAjaxView.as_view(),
        name="update_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_publications/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPublicationsAjaxView.as_view(),
        name="update_entity_publications",
    ),
    url(

panelapp/panels/models/codes.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
"""Enums used in the app"""

from enum import Enum


class ProcessingRunCode(Enum):
    PROCESSED = 0
    PROCESS_BACKGROUND = 1

panelapp/panels/forms/activity.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms


class ActivityFilterForm(forms.Form):
    panel = forms.ChoiceField(required=False, choices=list)
    version = forms.ChoiceField(required=False, choices=list)
    entity = forms.ChoiceField(
        label="Gene or Genomic Entity Name", required=False, choices=list
    )
    date_from = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )
    date_to = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )

    def __init__(self, *args, **kwargs):
        panels = kwargs.pop("panels")
        versions = kwargs.pop("versions")
        entities = kwargs.pop("entities")

        super().__init__(*args, **kwargs)

        self.fields["panel"].choices = [("", "Panel")] + list(panels)

        if versions:
            self.fields["version"].choices = [("", "Panel Version")] + list(versions)
        else:
            self.fields["version"].widget.attrs = {"disabled": "disabled"}

        if entities:
            self.fields["entity"].choices = [("", "")] + list(entities)
        else:
            self.fields["entity"].widget.attrs = {"disabled": "disabled"}

panelapp/panels/forms/geneready.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms
from panels.models import GenePanelEntrySnapshot


class GeneReadyForm(forms.ModelForm):
    """
    This class marks Gene as Ready and also adds a comment if it was provided.
    It also saves a new evidence with the current Gene status as an evidence.
    Additionally, we add save a TrackRecord to note this change, and record an activity
    """

    ready_comment = forms.CharField(
        label="Comment (eg What decisions are being made?)",
        required=False,
        widget=forms.Textarea,
    )

    class Meta:
        model = GenePanelEntrySnapshot
        fields = ("comments",)

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

        original_fields = self.fields
        self.fields = {}
        self.fields["ready_comment"] = original_fields.get("ready_comment")

    def save(self, *args, **kwargs):
        self.instance.mark_as_ready(
            self.request.user, self.cleaned_data["ready_comment"]
        )

panelapp/panels/templates/panels/activity_list.html
{% extends "default.html" %}
{% load qurl %}
{% load staticfiles %}
{% load panel_helpers %}
{% load bootstrap3 %}

{% block content %}
  <h1 class="add-bottom-margin">
      {% block title %}Activity{% endblock %}
      <a href="#" data-module="showhide" data-show=".form.activity-filter"><span class="fa fa-filter{% if filter_active %} text-primary{% else %} text-muted small{% endif %}"></span></a>
  </h1>

  <form class="form activity-filter add-bottom-margin{% if not filter_active %} hidden{% endif %}">
    <h4>Filter</h4>
    {% bootstrap_form filter_form %}
    <div>
      <a href="{% url 'panels:activity' %}" class="btn btn-default">Cancel</a>
      <button type="submit" class="btn btn-primary">Filter</button>
        {% if request.user.is_authenticated and request.user.reviewer.is_GEL %}
        <button type="submit" value="csv" name="format" class="btn btn-default">CSV Export</button>
        {% endif %}
    </div>
  </form>
  
  <table class="table table-bordered" data-module="filterable-table">
    <thead>
      <tr class="table-header">
        <th style="width: 10%">Date</th>
        <th style="width: 25%">Panel</th>
        <th style="width: 8%">Item</th>
        <th>Activity</th>
      </tr>
      <tr class="if-no-js-hide table-header-secondary">
        <td colspan="100">
          <form>
            <label for="gene-filter" class="rm">Filter activities</label>
            <div class="input-group">
              <input id="gene-filter" type="text" class="form-control normal js-filter-table-input" placeholder="Filter activities">
              <span class="input-group-addon js-filter-table-count" data-singular="action" data-plural="actions">
                {{ activities|length }} actions
              </span>
            </div>
          </form>
        </td>
      </tr>
    </thead>
    <tbody>
      {% for activity in activities %}
        <tr>
          <td>
            <time title="{{activity.created}}" datetime={{activity.created|date:'c'}}>{{ activity.created|date:"d M Y" }}</time>
          </td>
          <td>
            {% if activity.panel %}
              <a href="{{ activity.panel.get_absolute_url }}">{{ activity.panel.name }}{% if activity.panel_version %} v{{ activity.panel_version }}{% endif %}</a>
            {% endif %}
          </td>
          <td>
            {% if activity.entity_type %}
              <a href="{% url 'panels:evaluation' activity.panel_id activity.entity_type activity.entity_name %}">{{ activity.entity_name }}</a>
            {% endif %}
          </td>
          <td>
            {{ activity.user.get_full_name }} {{ activity.text|linebreaksbr }}
          </td>
        </tr>
      {% endfor %}
    </tbody>
  </table>

  {% if is_paginated %}
  <div class="pagination">
    <span class="step-links">
      {% if page_obj.has_previous %}
        <a href="{% qurl request.get_full_path page=page_obj.previous_page_number %}">Previous page</a>
      {% endif %}

      <span class="current">
        Page {{ page_obj.number }} of {{ paginator.num_pages }}.
      </span>

      {% if page_obj.has_next %}
        <a href="{% qurl request.get_full_path page=page_obj.next_page_number %}">Next page</a>
      {% endif %}
    </span>
  </div>
  {% endif %}
{% endblock %}

panelapp/panels/templates/panels/genepanel_detail.html
{% extends "default.html" %}
{% load staticfiles %}
{% load bootstrap3 %}
{% block header %}
<script src="{% static 'django_ajax/js/jquery.ajax.min.js' %}"></script>
<script src="{% static 'django_ajax/js/jquery.ajax-plugin.min.js' %}"></script>
{% endblock %}

{% block body %}
<div class="container">
  <ol class="breadcrumb">
      <li>
          <a href="{% url 'panels:index' %}">Panels</a>
      </li>
      <li class="active">
          {{ panel.level4title.name }}
      </li>
  </ol>

  {% if not panel.panel.is_public %}
  <div class="alert alert-danger" role="alert">This Panel is marked as {{ panel.panel.status|title }}</div>
  {% endif %}

    {% if signed_off %}
        <div class="alert alert-info" role="alert"><strong>{{ signed_off_message }}</strong></div>
    {% endif %}

  <div id="banner">
      <h1>
          {% block title %}{{ panel.level4title.name }} (Version {{ panel.major_version}}.{{ panel.minor_version}}){% endblock %}
      </h1>
      <p class="lead">
          {% if panel.level4title.level3title %}
              Level 3: {{ panel.level4title.level3title }}<br />
          {% endif %}
          {% if panel.level4title.level2title %}
              Level 2: {{ panel.level4title.level2title }}<br />
          {% endif %}
          {% if panel.old_panels and panel.old_panels.0 %}
              <br/>Relevant disorders: {{ panel.old_panels|join:", " }}
          {% endif %}
          {% if panel.is_super_panel %}
              <br />This panel contains these {{ panel.child_panels.all|length }} panels:
              {% for child_panel in panel.child_panels.all %}<br /><a href="{% url 'panels:detail' child_panel.panel.pk %}">{{ child_panel }}</a> {% endfor %}
          {% endif %}
          {% if panel.panel.types.all %}
              <br />Panel types: {% for type in panel.panel.types.all %}{{ type.name }}{% if not forloop.last %}, {% endif %}{% endfor %}
          {% endif %}
          {% if signed_off %}
             <br />Panel version {{ signed_off.major_version }}.{{ signed_off.minor_version }} has been signed off on {{ signed_off.signed_off_date }}
          {% endif %}

          {% if panel.panel.old_pk %}<br />Previous code: {{ panel.panel.old_pk }}{% endif %}
      </p>
  </div>

  <div class="row">
      <div class="col-md-8" id="panel_info">
          {% include "panels/genepanel_info.html" %}
      </div>
      <div class="col-md-4">
          {% if not panel.is_super_panel and contributors %}
              <h3 class="remove-top-margin add-bottom-margin">{{ contributors|length }} reviewer{{ contributors|pluralize }}</h3>
              <ul class="list-group remove-bottom-margin">
              {% for contributor in contributors %}
                  <li class="list-group-item">
                      <p class="bold">{{ contributor.get_full_name }} ({{contributor.reviewer.affiliation}})</p>
                      <p class="text-muted">
                          Group: {{ contributor.reviewer.group }}<br />
                          Workplace: {{ contributor.reviewer.workplace }}
                          {% if request.user.is_authenticated and request.user.reviewer.is_GEL %}
                              <br /><a href="mailto:{{ contributor.email }}" class="link-muted word-break">{{ contributor.email }}</a>
                          {% endif %}
                      </p>
                  </li>
              {% endfor %}
              </ul>
          {% endif %}
      </div>
  </div>

{% with entities=panel.get_all_entities_extra %}
  <h2 class="add-label-margin">{{ entities|length }} Entities</h2>
  <h3 class="text-muted normal remove-top-margin add-bottom-margin">{{ panel.stats.number_of_evaluated_entities }} reviewed{% if request.user.is_authenticated and request.user.reviewer.is_GEL %}, {{ panel.stats.number_of_ready_entities }} ready{% endif %}, {{ panel.stats.number_of_green_entities }} green</h3>

  <div data-module="sortable-table" data-default-key="entity">
      <div class="table-responsive" data-module="filterable-table">
          <table class="table table-bordered table-hover" id="entities_table">
            {% include "panels/entities_list_table.html" with is_super_panel=panel.is_super_panel %}
          </table>
      </div>
  </div>
{% endwith %}

  {% if panel.version_comment and panel.major_version %}
     <h2>Major version comments</h2>
      <ul class="list-group remove-bottom-margin">
          <li class="list-group-item">
              <p class="remove-bottom-margin">{{ panel.version_comment|linebreaksbr }}</p>
          </li>
      </ul>
  {% endif %}

  {% if not panel.is_super_panel and request.user.is_authenticated and request.user.reviewer.is_GEL %}
      <h3 class="add-top-margin">Promote to version {{ panel.major_version|add:"1" }}</h3>
      <div class="well">
          <p>Promoting a panel will:</p>
          <ul>
              <li>email all reviewers, thanking them for their contribution</li>
              <li>reset the "ready" flag on all genes</li>
              <li>increase the major version of the panel</li>
          </ul>
          <form action="{% url 'panels:promote' panel.panel.id %}" method="post" class="form add-top-margin">
              {% csrf_token %}
              <fieldset>
                  {% for field in promote_panel_form %}
                      <div class="form-group">
                          {% if field.errors %}
                              {% for error in field.errors %}
                                  <span class="label label-danger">{{ error|escape }}</span>
                              {% endfor %}
                          {% endif %}
                          {% bootstrap_field field %}
                      </div>
                  {% endfor %}
                  <input type="submit" class="btn btn-info" value="Increase Version">
              </fieldset>
          </form>
      </div>
  {% endif %}

  <h2>Downloads</h2>
  <div class="well">
    <h3 class="remove-top-margin">Download lists</h3>
    <ul>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '01234' %}">Whole panel</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '34' %}">Green list (high evidence)</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '234' %}">Green and Amber Genes</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '2' %}">Amber Genes</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '01' %}">Red list (low evidence)</a></li>
    </ul>
    <h3>Download Version</h3>
      <div class="form-row">
          <div class="col">
            <div class="form-group">
            <div class="inline-group">
            <form class="form-inline" action="{% url 'panels:download_old_panel_tsv' panel.panel.id %}" method="post">
            {% csrf_token %}
            <input type="text" value="" placeholder="Panel version, for example 0.1", name="panel_version" class="input form-control">
              <button type="submit" class="btn btn-primary">Download</button></form>
            </div>
            </div>
        </div>
    {% if signed_off %}
    <div class="col">
        <div class="form-group">
          <div class="inline-group">
              <form class="form" action="{% url 'panels:download_old_panel_tsv' panel.panel.id %}" method="post">{% csrf_token %}
              <input type="hidden" value="{{ signed_off.major_version }}.{{ signed_off.minor_version }}" name="panel_version" class="input form-control">
              <button type="submit" class="btn btn-primary">Download Signed-Off Version</button>
              </form>
          </div>
        </div>
    </div>
    {% endif %}
      </div>
  </div>
</div>
{% endblock %}